#include	"stdio.h"
#include	"stdlib.h"
#include	"time.h"
#include	"math.h"
#include	"forms.h"
#include	"device.h"
#include	"sys/types.h"
#include	"sys/stat.h"

#define min(a,b) ((a<b)?a:b)
#define max(a,b) ((a>b)?a:b)

/*
#include "printform.h"
*/

static FL_FORM *printform;

static FL_OBJECT
        *printerbrowser,
        *printbutton,
        *scalinglabel,
        *orientationlabel,
        *scalinginput,
        *scalechoice,
        *stylegroup,
        *outlinebutton,
        *regularbutton,
        *orientationchoice,
        *printtofilebutton,
        *epsbutton,
        *copiesinput,
        *printerlabel,
        *cancelbutton;

static void create_form_printform(void)
{
  FL_OBJECT *obj;
  printform = fl_bgn_form(FL_NO_BOX,540.0,300.0);
  obj = fl_add_box(FL_BORDER_BOX,0.0,0.0,540.0,300.0,"");
  obj = fl_add_box(FL_FRAME_BOX,365.0,60.0,165.0,160.0,"");
    fl_set_object_lsize(obj,11.000000);
  obj = fl_add_box(FL_FRAME_BOX,10.0,220.0,520.0,70.0,"");
    fl_set_object_lsize(obj,11.000000);
  obj = fl_add_box(FL_FRAME_BOX,10.0,10.0,520.0,50.0,"");
    fl_set_object_lsize(obj,11.000000);
  obj = fl_add_box(FL_FRAME_BOX,10.0,60.0,360.0,160.0,"");
    fl_set_object_lsize(obj,11.000000);
  printerbrowser = obj = fl_add_browser(FL_HOLD_BROWSER,380.0,110.0,140.0,80.0,"");
    fl_set_object_color(obj,47,7);
  printbutton = obj = fl_add_button(FL_RETURN_BUTTON,440.0,20.0,80.0,30.0,"Print");
  scalinglabel = obj = fl_add_text(FL_NORMAL_TEXT,40.0,100.0,80.0,30.0,"Scaling:");
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_align(obj,FL_ALIGN_RIGHT);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  orientationlabel = obj = fl_add_text(FL_NORMAL_TEXT,20.0,140.0,100.0,30.0,"Orientation:");
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_align(obj,FL_ALIGN_RIGHT);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  scalinginput = obj = fl_add_input(FL_FLOAT_INPUT,120.0,100.0,60.0,30.0,"");
    fl_set_object_color(obj,47,9);
  scalechoice = obj = fl_add_choice(FL_NORMAL_CHOICE,190.0,100.0,170.0,30.0,"");
    fl_set_object_boxtype(obj,FL_FRAME_BOX);
  stylegroup = fl_bgn_group();
  outlinebutton = obj = fl_add_lightbutton(FL_RADIO_BUTTON,250.0,255.0,110.0,30.0,"B&W Outlines");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,47,3);
  regularbutton = obj = fl_add_lightbutton(FL_RADIO_BUTTON,120.0,255.0,120.0,30.0,"Coloured Solids");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,47,3);
  fl_end_group();
  orientationchoice = obj = fl_add_choice(FL_NORMAL_CHOICE,120.0,140.0,240.0,30.0,"");
    fl_set_object_boxtype(obj,FL_FRAME_BOX);
  printtofilebutton = obj = fl_add_lightbutton(FL_PUSH_BUTTON,120.0,180.0,120.0,30.0,"Print to File...");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,47,3);
  epsbutton = obj = fl_add_lightbutton(FL_PUSH_BUTTON,120.0,225.0,265.0,30.0,"Output as Encapsulated Postscript (EPS)");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,47,3);
  copiesinput = obj = fl_add_input(FL_INT_INPUT,480.0,70.0,40.0,30.0,"# Copies:");
    fl_set_object_color(obj,47,9);
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  printerlabel = obj = fl_add_text(FL_NORMAL_TEXT,370.0,190.0,150.0,20.0,"Printer:");
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  cancelbutton = obj = fl_add_button(FL_NORMAL_BUTTON,350.0,20.0,80.0,30.0,"Cancel");
  obj = fl_add_text(FL_NORMAL_TEXT,15.0,225.0,105.0,30.0,"Postscript:");
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_align(obj,FL_ALIGN_RIGHT);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,20.0,180.0,100.0,30.0,"Output:");
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_align(obj,FL_ALIGN_RIGHT);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,15.0,255.0,105.0,30.0,"Print Quality:");
    fl_set_object_lsize(obj,11.000000);
    fl_set_object_align(obj,FL_ALIGN_RIGHT);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fl_end_form();
}

/*---------------------------------------*/

static void create_printform(void)
{
  create_form_printform();
}


FILE	*_fl_ps = NULL;		/* copy of user-passed file pointer, made visible
							   in all classes so that postscript output
							   can go into this stream */
#define PSFIULEN 1024
int	 	Psfiulen = PSFIULEN;
char	Psfontsinuse[PSFIULEN];

static void postscriptprolog(FILE *, int, int, float, float, float);
static void postscriptpostlog();

/* Following needed for fl_ps_all_forms */
extern FL_FORM *forms[];
extern formnumb;

void fl_ps_all_forms(FILE *fp, int orientation, float scaling, int style)
/* Renders all currently active forms in their relative locations */
{
	FL_FORM *form;
	FL_OBJECT *ob;
	int	postscriptevent = FL_POSTSCRIPT;
	int deepest, deepestindex, i, j;
	int *stacking;
	int minx = 2000, miny = 2000, maxx = 0, maxy = 0;
	float	w, h;

	if (fp == NULL) {
		fl_error("fl_ps_all_forms","Trying to render form to NULL file.");
		return;
	}
	if ((style == FL_PS_RENDER_EPSOUTLINE) || (style == FL_PS_RENDER_PSOUTLINE))
		postscriptevent = FL_PSOUTLINE;

	stacking = (int *)malloc(formnumb*sizeof(int));

	for (i = 0; i < formnumb; i++) {
		/* mark stacking order, calc bounding box */
		stacking[i] = windepth(forms[i]->window);
		minx = min(minx, forms[i]->x);
		miny = min(miny, forms[i]->y);
		maxx = max(maxx, forms[i]->x+(int)(forms[i]->w));
		maxy = max(maxy, forms[i]->y+(int)(forms[i]->h));
	}
	w = (float)(maxx-minx);
	h = (float)(maxy-miny);


	postscriptprolog(fp, orientation, style, w, h, scaling);
	for (i = 0; i < formnumb; i++) {
		/* bubble sort through forms stacking order */
		deepest = -1;
		for (j = 0; j < formnumb; j++) {
			if (stacking[j] > deepest) {
				deepest = stacking[j];
				deepestindex = j;
			}
		}
		/* deepest unrendered window is forms[deepestindex] */
		fprintf(fp, "gsave\n");
		fprintf(fp, "%%Begin of Form\n");
		fprintf(fp, "%d %d translate\n",
			forms[deepestindex]->x-minx,
			forms[deepestindex]->y-miny);
		ps_set_clipping(0.0,0.0,
			forms[deepestindex]->w+1,forms[deepestindex]->h+1);
		ob = forms[deepestindex]->first;
		for (ob = forms[deepestindex]->first; ob != NULL; ob = ob->next)
			if (ob->visible) fl_handle_object(ob,postscriptevent,0.,0.,0);
		ps_unset_clipping();
		fprintf(fp, "%%End of Form\n");
		fprintf(fp, "grestore\n");
		/* mark as rendered */
		stacking[deepestindex] = -1;
	}
	postscriptpostlog();
}

void fl_ps_form(FL_FORM *form, FILE *fp,
				int orientation, float scaling, int style)
/* Renders form */
{
	FL_OBJECT *ob;
	int	postscriptevent = FL_POSTSCRIPT;

	if (form == NULL)
		{ fl_error("fl_ps_form","Trying to render NULL form."); return;}
	if (fp == NULL)
		{ fl_error("fl_ps_form","Trying to render form to NULL file."); return;}

	if ((style == FL_PS_RENDER_EPSOUTLINE) || (style == FL_PS_RENDER_PSOUTLINE))
		postscriptevent = FL_PSOUTLINE;

	postscriptprolog(fp, orientation, style, form->w, form->h, scaling);
	/* prevent output outside form bounding box */
	ps_set_clipping(0.0, 0.0, form->w+1, form->h+1);

	for (ob = form->first; ob != NULL; ob = ob->next) 
		if (ob->visible) fl_handle_object(ob,postscriptevent,0.,0.,0);

	ps_unset_clipping();
	postscriptpostlog();
}

void fl_ps_object(FL_OBJECT *ob, FILE *fp,
				int orientation, float scaling, int style)
/* Renders object */
{
  int	postscriptevent = FL_POSTSCRIPT;

  if (ob == NULL)
    { fl_error("fl_ps_object","Trying to render NULL object."); return;}

  if (fp == NULL)
	{ fl_error("fl_ps_object","Trying to render form to NULL file."); return;}

  if ((style == FL_PS_RENDER_EPSOUTLINE) || (style == FL_PS_RENDER_PSOUTLINE))
	postscriptevent = FL_PSOUTLINE;

  postscriptprolog(fp, orientation, style, ob->w, ob->h, scaling);
  ps_set_clipping(0.0, 0.0, ob->w+1, ob->h+1);
  if (ob->objclass == FL_BEGIN_GROUP)
	/* When ob is a group, render all objects in the group */
    while ( ob != NULL && ob->objclass != FL_END_GROUP)
		if (ob->visible) fl_handle_object(ob,postscriptevent,0.,0.,0);
  else
	fl_handle_object(ob,postscriptevent,0.,0.,0);
  ps_unset_clipping();
  postscriptpostlog();
}

FILE *fl_ps_openoutputstream(int * orientation,
	float *scaling, int *style)
{
	/* Input: nothing
	   Output: returns a file pointer, which is either a pipe to lp
	   or a file on disk. Pointers to orientation, style and scaling
	   can be used as input to fl_ps_all_forms, fl_ps_form or fl_ps_object.
	   Returns NULL when cancelled. */
	static int printform_created = FALSE;
	FILE	*fp;
	char	line[80];
	char	lpcmd[256];
	char	*filename, *selectedprinter;
	int		n = 1, i = -1, wantto = 0;
	FL_OBJECT	*retobj;
	
	/* Step 1. Build form when not built earlier */
	if (!printform_created) {
		create_printform();
		fl_addto_choice(scalechoice, "Match size on 16\" monitor");
		fl_addto_choice(scalechoice, "Match size on 19\" monitor");
		fl_addto_choice(scalechoice, "Fill page");
		fl_addto_choice(scalechoice, "Don't scale");
		fl_addto_choice(scalechoice, "Custom");
		fl_addto_choice(orientationchoice, "Portrait");
		fl_addto_choice(orientationchoice, "Landscape");
		fl_addto_choice(orientationchoice, "Best Fit");
		printform_created = TRUE;

		/* Step 2. Set some useful defaults in form when not done before. */
		fl_set_button(regularbutton, 1);
		fl_set_button(outlinebutton, 0);
		fl_set_input(scalinginput, "0.65");
		fl_set_input_return(scalinginput, 1);
		fl_set_input(copiesinput, "1");
		fl_set_button(printtofilebutton, wantto);
		fl_set_button(epsbutton, 0);

		/* Step 3. Find names for all defined printers, and for the default. */
		fp = popen("lpstat -d -a | awk '/accepting/ {if ($2 != \"not\") print $1}; /^system default destination:/ { print $4 }; /^no system default destination/ { print \"none\"} '", "r");
		while (fgets(line, 80, fp) != NULL) {
			line[strlen(line)-1] = 0;
			fl_add_browser_line(printerbrowser, line);
		}
		pclose(fp);
		fp = NULL;
		for (i=2; fl_get_browser_maxline(printerbrowser); i++) {
			/* select default printer */
			if (strcmp(fl_get_browser_line(printerbrowser, 1),
					   fl_get_browser_line(printerbrowser, i)) == 0) {
				fl_select_browser_line(printerbrowser, i);
				fl_delete_browser_line(printerbrowser, 1);
				break;
			}
		}
	}

	/* Step 4. Do form */
	fl_deactivate_all_forms();
	fl_show_form(printform,FL_PLACE_SIZE,FALSE,"");
	do {
		retobj = fl_do_only_forms();
		if (retobj == scalinginput) {
			fl_set_choice(scalechoice, 5);
		} else if (retobj == scalechoice) {
			switch (fl_get_choice(scalechoice)) {
			case 1:
				fl_set_input(scalinginput, "0.65");
				break;
			case 2:
				fl_set_input(scalinginput, "0.75");
				break;
			case 3:
				fl_set_input(scalinginput, "0.0");
				break;
			case 4:
				fl_set_input(scalinginput, "1.0");
				break;
			case 5:
				break;
			}
		} else if (retobj == epsbutton) {
			if (fl_get_button(epsbutton)) {
				fl_deactivate_form(printform);
				fl_set_button(printtofilebutton, 1);
				fl_deactivate_object(printtofilebutton);
				fl_hide_object(copiesinput);
				fl_hide_object(printerbrowser);
				fl_hide_object(orientationchoice);
				fl_hide_object(scalechoice);
				fl_hide_object(scalinginput);
				fl_hide_object(printerlabel);
				fl_hide_object(orientationlabel);
				fl_hide_object(scalinglabel);
				fl_activate_form(printform);
			} else {
				fl_deactivate_form(printform);
				fl_set_button(printtofilebutton, wantto);
				fl_activate_object(printtofilebutton);
				if (!wantto) {
					fl_show_object(copiesinput);
					fl_show_object(printerbrowser);
					fl_show_object(printerlabel);
				}
				fl_show_object(orientationchoice);
				fl_show_object(scalechoice);
				fl_show_object(scalinginput);
				fl_show_object(orientationlabel);
				fl_show_object(scalinglabel);
				fl_activate_form(printform);
			}
		} else if (retobj == scalinginput) {
				fl_set_choice(scalechoice, 5);
		} else if (retobj == printtofilebutton) {
			fl_deactivate_form(printform);
			if (fl_get_button(printtofilebutton)) {
				wantto = 1;
				fl_hide_object(copiesinput);
				fl_hide_object(printerbrowser);
				fl_hide_object(printerlabel);
			} else {
				wantto = 0;
				fl_show_object(copiesinput);
				fl_show_object(printerbrowser);
				fl_show_object(printerlabel);
			}
			fl_activate_form(printform);
		}
	} while ((retobj != printbutton) && (retobj != cancelbutton));
	fl_hide_form(printform);
	if (retobj == cancelbutton) {
		fl_activate_all_forms();
		return NULL;
	}

	/* Step 5. On printbutton: set style, orientation, scaling
							   If print to file: use fl_file_selector
							   to get a valid file name. Open that file
							   for writing, return file desriptor.
							   If print to printer: popen to lp process,
							   using -dPRINTERNAME -nCopies */
	*orientation = fl_get_choice(orientationchoice);
	switch (*orientation) {
	case 1:
		*orientation = FL_PS_ORIENT_PORTRAIT;
		break;
	case 2:
		*orientation = FL_PS_ORIENT_LANDSCAPE;
		break;
	case 3:
		*orientation = FL_PS_ORIENT_BESTFIT;
		break;
	}
	*style = fl_get_button(regularbutton);
	switch (*style) {
	case 1:
		if (fl_get_button(epsbutton)) *style = FL_PS_RENDER_EPS;
		else *style = FL_PS_RENDER_POSTSCRIPT;
		break;
	case 0:
		if (fl_get_button(epsbutton)) *style = FL_PS_RENDER_EPSOUTLINE;
		else *style = FL_PS_RENDER_PSOUTLINE;
		break;
	}
	*scaling = atof(fl_get_input(scalinginput));
	n = atoi(fl_get_input(copiesinput));
	if (n == 0) n = 1;
	if (fl_get_button(printtofilebutton)) {
		do {
			filename = fl_show_file_selector("Specify Filename:",
				NULL, "*.ps", NULL);
			if (filename == NULL) {
				fl_activate_all_forms();
				return NULL;
			} else {
				fp = fopen(filename, "w");
				if (fp) break;
				fl_show_message("Could not open file for writing:", filename,
					"Specify other filename");
			}
		} while (1);
	} else {
		selectedprinter = fl_get_browser_line(printerbrowser,
			fl_get_browser(printerbrowser));
		sprintf(lpcmd, "lp -d%s -n%d -", selectedprinter, n);
		if ((fp = popen(lpcmd, "w")) == NULL) {
			fl_show_message("Failed to schedule output:", 
				"Could not create lp process",
				"File not printed");
			return NULL;
		}
	}
	fl_activate_all_forms();
	return fp;
}

void fl_ps_closeoutputstream(FILE *fp)
{
	struct stat buf;

	if (fp == NULL) return;
	if (fstat(fileno(fp), &buf) == -1) return;
	if (buf.st_mode == S_IFIFO)
		pclose(fp);
	else
		fclose(fp);
}

int fl_handleprintscreen(FL_FORM *form)
/* Processes keyboard event 'Print Screen'. May be redefined by user code. */
{
	int	style;
	int	orientation;
	float scaling;
	FILE	*psfile;
	int	allforms = FALSE;

	if (getbutton(RIGHTSHIFTKEY) || getbutton(LEFTSHIFTKEY)) allforms = TRUE;

	psfile = fl_ps_openoutputstream(&orientation, &scaling, &style);
	if (psfile == NULL) return 0;

	if (allforms)
		fl_ps_all_forms(psfile, orientation, scaling, style);
	else
		fl_ps_form(form, psfile, orientation, scaling, style);

	fl_ps_closeoutputstream(psfile);
	return 1;
}

static void postscriptprolog(FILE *fp, int orientation,
	int style, float w, float h, float scaling)
{
  int	eps = 0;
  time_t t;

  if ((style != FL_PS_RENDER_POSTSCRIPT) &&
	  (style != FL_PS_RENDER_PSOUTLINE) &&
	  (style != FL_PS_RENDER_EPS) &&
	  (style != FL_PS_RENDER_EPSOUTLINE)) {
	fl_error("fl_ps_form","Unknown rendering style."); return;
  }
  if ((style == FL_PS_RENDER_EPSOUTLINE) || (style == FL_PS_RENDER_EPS)) 
	eps = 1;
  strcpy(Psfontsinuse, "");

  _fl_ps = fp;
  fprintf(_fl_ps, "%%!PS-Adobe-2.0%s\n", (eps)?" EPSF-2.0":"");
  fprintf(_fl_ps, "%%%%BoundingBox: %d %d %d %d\n", 0, 0, (int)w, (int)h);
  fprintf(_fl_ps, "%%%%Title: Forms Postscript Rendering\n");
  fprintf(_fl_ps, "%%%%Creator: Forms Library 2.2\n");
  t = time(NULL);
  fprintf(_fl_ps, "%%%%CreationDate: %s", asctime(localtime(&t)));
  fprintf(_fl_ps, "%%%%Documentfonts: (atend)\n");
  fprintf(_fl_ps, "%%%%Pages: 1\n");
  fprintf(_fl_ps, "%%%%EndComments\n");
  fprintf(_fl_ps, "%%%%Page: 1 1\n");
  fprintf(_fl_ps, "gsave\n");
  if (eps) {
	  if (style == FL_PS_RENDER_EPS) {
		fprintf(_fl_ps, "%%Renderstyle: EPS\n");
	  } else if (style == FL_PS_RENDER_EPSOUTLINE) {
		fprintf(_fl_ps, "%%Renderstyle: EPS Outline\n");
	  }
	  scaling = 1.0;
  } else {
	  if (style == FL_PS_RENDER_POSTSCRIPT) {
		fprintf(_fl_ps, "%%Renderstyle: Postscript\n");
	  } else if (style == FL_PS_RENDER_PSOUTLINE) {
		fprintf(_fl_ps, "%%Renderstyle: Postscript Outline\n");
	  }
	  fprintf(_fl_ps, "newpath clippath pathbbox\n");
	  fprintf(_fl_ps, "/URy exch def\n");
	  fprintf(_fl_ps, "/URx exch def\n");
	  fprintf(_fl_ps, "/LLy exch def\n");
	  fprintf(_fl_ps, "/LLx exch def\n");
	  fprintf(_fl_ps, "/Width  URx LLx sub 0.005 sub def\n");
	  fprintf(_fl_ps, "/Height URy LLy sub 0.005 sub def\n");
	  fprintf(_fl_ps, "LLx LLy translate\n");
	  if (orientation == FL_PS_ORIENT_BESTFIT) {
		fprintf(_fl_ps, "%%Orientation: Bestfit\n");
		fprintf(_fl_ps, "%d %d gt Width Height lt and\n",
			(int)(w), (int)(h));
		fprintf(_fl_ps, "%d %d lt Width Height gt and or\n",
			(int)(w), (int)(h));
		fprintf(_fl_ps, "{	90 rotate\n");
		fprintf(_fl_ps, "	0 Width neg translate\n");
		fprintf(_fl_ps, "	Width Height /Width exch def /Height exch def } if\n");
	  } else if (orientation == FL_PS_ORIENT_PORTRAIT) {
		fprintf(_fl_ps, "%%Orientation: Portrait\n");
		fprintf(_fl_ps, "Width Height gt\n");
		fprintf(_fl_ps, "{	90 rotate\n");
		fprintf(_fl_ps, "	0 Width neg translate\n");
		fprintf(_fl_ps, "	Width Height /Width exch def /Height exch def } if\n");
	  } else if (orientation == FL_PS_ORIENT_LANDSCAPE) {
		fprintf(_fl_ps, "%%Orientation: Landscape\n");
		fprintf(_fl_ps, "Width Height lt\n");
		fprintf(_fl_ps, "{	90 rotate\n");
		fprintf(_fl_ps, "	0 Width neg translate\n");
		fprintf(_fl_ps, "	Width Height /Width exch def /Height exch def } if\n");
	  } else {
		fl_error("fl_ps_form","Unknown orientation type"); return;
	  }
	if (scaling == FL_PS_SCALE_DONTSCALE) {
		fprintf(_fl_ps, "%%Scale: Dontscale\n");
		fprintf(_fl_ps, "Width  %d sub 2 div\n", (int)(w));
		fprintf(_fl_ps, "Height %d sub 2 div translate\n", (int)(h));
	} else if (scaling == FL_PS_SCALE_16INCH) {
		fprintf(_fl_ps, "%%Scale: Match 16\" monitor\n");
		fprintf(_fl_ps, "Width  %d sub 2 div\n", (int)(0.65*w));
		fprintf(_fl_ps, "Height %d sub 2 div translate\n", (int)(0.65*h));
		fprintf(_fl_ps, "0.65 0.65 scale\n");
	} else if (scaling == FL_PS_SCALE_19INCH) {
		fprintf(_fl_ps, "%%Scale: Match 19\" monitor\n");
		fprintf(_fl_ps, "Width  %d sub 2 div\n", (int)(0.75*w));
		fprintf(_fl_ps, "Height %d sub 2 div translate\n", (int)(0.75*h));
		fprintf(_fl_ps, "0.75 0.75 scale\n");
	} else if (scaling == FL_PS_SCALE_FITPAGE) {
		scaling = 1.0;
		fprintf(_fl_ps, "%%Scale: Fitpage\n");
		fprintf(_fl_ps, "Width %d div Height %d div gt\n",
			(int)(w), (int)(h));
		fprintf(_fl_ps, "	{ /Y_size Height def\n");
		fprintf(_fl_ps, "		/X_size %d %d div Y_size mul def\n",
			(int)(w), (int)(h));
		fprintf(_fl_ps, "		/Scale Height %d div def }\n",
			(int)(h));
		fprintf(_fl_ps, "	{ /X_size Width def\n");
		fprintf(_fl_ps, "		/Y_size %d %d div X_size mul def\n",
			(int)(h), (int)(w));
		fprintf(_fl_ps, "		/Scale Width %d div def } ifelse\n",
		(int)(w));
		fprintf(_fl_ps, "Width  X_size sub 2 div\n");
		fprintf(_fl_ps, "Height Y_size sub 2 div translate\n");
		fprintf(_fl_ps, "Scale Scale scale\n");
	} else if (scaling <= 0.0) {
		fl_error("fl_ps_form","Trying to scale with negative scaling.");
	} else {
		fprintf(_fl_ps, "%%Scale: Custom scaling %f\n", scaling);
		fprintf(_fl_ps, "Width  %d sub 2 div\n",
			(int)(scaling*w));
		fprintf(_fl_ps, "Height %d sub 2 div translate\n",
			(int)(scaling*h));
		fprintf(_fl_ps, "%f %f scale\n", scaling, scaling);
	}
  }
  fprintf(_fl_ps, "%% Forms non-default settings\n");
  fprintf(_fl_ps, "2 setlinecap\n");
  fprintf(_fl_ps, "%% Begin of Forms rendering\n");
}

static void postscriptpostlog()
{
  fprintf(_fl_ps, "grestore\n");
  fprintf(_fl_ps, "showpage\n");
  fprintf(_fl_ps, "%%%%Trailer\n");
  fprintf(_fl_ps, "%%%%Documentfonts: %s\n", Psfontsinuse);
  fprintf(_fl_ps, "%%%%EOF\n");
  _fl_ps = NULL;
}
